.586
.model flat, stdcall
option casemap:none

	include windows.inc
	include masm32.inc				; atodw
	include user32.inc
	include kernel32.inc
	includelib masm32.lib				; atodw
	includelib user32.lib
	includelib kernel32.lib

	DlgProc PROTO :DWORD,:DWORD,:DWORD,:DWORD

.data
	Failure			DB "Cannot load ROAK.VXD!", 0
	ErrorMsg			DB "ERROR!", 0
	VxDName			DB "\\.\roak.vxd", 0
	SectorTitle			DB "SECTOR OF CD:", 0
	err_buf			DB 'ERROR READING CD SECTOR!', 0

.data?
	hInstance			HINSTANCE ?
	hVxD				DD ?
	BytesReturned		DD ?
	drive_letter		DD ?
	sector_number		DD ?
	sector_buffer		DB 2048 dup(?)
	target_buffer		DB 30 dup(?)
_roak_read_struc			STRUC
	read_write_cd_function	DW ?		; 1508h for read
	drive				DW ?		; A = 0
	number_sectors_to_read	DW ?		; # of sectors to read or write
	sector_number_high	DW ?		; starting sector number high
	sector_number_low		DW ?		; starting sector number low
_roak_read_struc			ENDS
	cd_read_struc		_roak_read_struc <>

.const
	IDD_VXDRUN			EQU 1000
	IDC_LOAD			EQU 2000
	IDC_EDIT_DRIVE		EQU 3000
	IDC_EDIT_SECTOR		EQU 4000

.code
start:

	invoke GetModuleHandle, 0
	mov hInstance, EAX
	invoke DialogBoxParam, hInstance, IDD_VXDRUN , 0, addr DlgProc, 0
	invoke ExitProcess, EAX

;.........................................................................
; DIALOG PROCEDURE
;.........................................................................
DlgProc proc hDlg:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	.IF uMsg == WM_INITDIALOG
	invoke CreateFile, addr VxDName, 0, 0, 0, 0, \
				4000000h, 0	; FILE_FLAG_DELETE_ON_CLOSE = 4000000h 
	.if EAX == INVALID_HANDLE_VALUE
	invoke MessageBox, hDlg, addr Failure, addr ErrorMsg, 0
	mov hVxD, 0
	invoke EndDialog, hDlg, NULL
	.else
	mov hVxD, EAX
	.endif
	.elseif uMsg == WM_CLOSE
	.if hVxD != 0
	invoke CloseHandle, hVxD
	.endif
	invoke EndDialog, hDlg, 0
	.ELSEIF uMsg == WM_COMMAND
	mov EAX, wParam
	mov EDX, wParam
	shr EDX, 16
	.if DX == BN_CLICKED
	.IF AX == IDC_LOAD
	invoke GetDlgItemText, hDlg, 3000, ADDR drive_letter, 32
	invoke GetDlgItemText, hDlg, 4000, ADDR sector_number, 32
	call prepare_stuff
	invoke DeviceIoControl, hVxD, 1, addr cd_read_struc, sizeof cd_read_struc, \
				addr sector_buffer, sizeof sector_buffer, addr BytesReturned, 0
	call zero_buffer
	invoke MessageBox, hDlg, ADDR sector_buffer, ADDR SectorTitle, 0
	.endif
	.endif
	.ELSE
	mov EAX, FALSE
	ret
	.ENDIF
	mov EAX, TRUE
	ret
DlgProc endp
;.........................................................................
; PROCEDURE TO PUT STUFF INTO STRUCTURE TO SEND TO VXD
;.........................................................................
prepare_stuff proc
	mov EAX, drive_letter
	.if (AL > 64 && AL < 91)
	sub AL, 65
	.endif
	.if (AL > 96 && AL < 123)
	sub AL, 97
	.endif
	mov AH, 0
	mov cd_read_struc.drive, AX			; drive
	invoke atodw, ADDR sector_number
	mov cd_read_struc.sector_number_low, AX	; put low part of sector number into structure
	shr EAX, 16
	mov cd_read_struc.sector_number_high, AX	; put high part of sector number into structure
	mov cd_read_struc.read_write_cd_function, 1508h
	mov cd_read_struc.number_sectors_to_read, 1
	ret
prepare_stuff endp
;.........................................................................
; PROCEDURE TO REPLACE ZEROES IN BUFFER WITH 32'S
;.........................................................................
zero_buffer proc
	LOCAL COUNTER:DWORD
	mov COUNTER, 0
	.repeat
	mov EBX, COUNTER
	inc COUNTER
	.if (sector_buffer[EBX] == 0)
	mov sector_buffer[EBX], 32
	.endif
	.until (COUNTER == 2048)
;
	invoke lstrcpyn, ADDR target_buffer, ADDR sector_buffer, 25
	invoke lstrcmpi, ADDR err_buf, ADDR target_buffer
	.if (EAX == 0)
	mov sector_buffer[24], 0
	.endif
	ret
zero_buffer endp
;.........................................................................
end start
